]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame_incremental - rpm.macros
- typo in cmake_on_off description
[packages/rpm-build-macros.git] / rpm.macros
... / ...
CommitLineData
1# vim:ts=4 sw=4 noet ft=spec
2#
3# PLD Linux rpm macros.
4# <http://www.pld-linux.org/>
5
6# can be used by builder script to check for version
7%rpm_build_macros {Revision}
8
9%epoch 0
10%x8664 x86_64 amd64 ia32e
11
12# compiler version
13%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion 2>/dev/null || echo 0.0)}%cc_version
14%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion 2>/dev/null || echo 0.0)}%cxx_version
15
16%__rm /bin/rm --interactive=never
17
18# Build system path macros.
19%__autoconf autoconf %{?debug:-Wall}
20%__automake automake -a -c -f --foreign
21%__autopoint autopoint --force
22
23# add parallel build flags: -jN
24# jobs macro is available since 1.657
25#
26# if you want to disable parallel build do:
27# echo '%__jobs %{nil}' >> ~/.rpmmacros
28%__jobs %{expand:%%global __jobs %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); [ "$_NCPUS" -gt 3 ] && echo $(($_NCPUS / 2)))%%{nil}}%__jobs
29
30# expands to -jN if %__jobs has a value
31%_smp_mflags %{expand:%%global _smp_mflags %(jobs=%{__jobs}; echo ${jobs:+-j$jobs}%%{nil})}%_smp_mflags
32
33%__make /usr/bin/make %{?_make_opts} %{?_smp_mflags}
34%__scons /usr/bin/scons %{?_smp_mflags}
35%__waf /usr/bin/waf %{?_smp_mflags}
36%__cmake /usr/bin/cmake -Wno-dev
37%__meson /usr/bin/meson
38%__meson_wrap_mode nodownload
39%__ninja /usr/bin/ninja
40%__ninja_common_opts -v %{?_smp_mflags}
41
42%__gettextize { \
43 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
44 gettextize --copy --force --no-changelog; \
45 else \
46 gettextize --copy --force --no-changelog --intl; \
47 fi; \
48 if [ ! -f po/Makevars ]; then \
49 cp -f po/Makevars{.template,}; \
50 fi; \
51}
52
53%__glib_gettextize glib-gettextize --copy --force
54%__gnome_doc_common gnome-doc-common --copy
55%__gnome_doc_prepare gnome-doc-prepare --copy --force
56%__gtkdocize gtkdocize --copy
57%__intltoolize intltoolize --copy --force
58%__libtoolize libtoolize --copy --force --install
59
60# topdir is where builder script lives,
61# fallback to old style if SPECS/SOURCES dirs were found.
62%_topdir %{expand:%%global _topdir %(
63 if [ -d SPECS -a -d SOURCES ]; then
64 # old style rpmdir: in topdir
65 pwd
66 elif [ -d ../SPECS -a -d ../SOURCES ]; then
67 # old style rpmdir: in subdir
68 cd ..; pwd
69 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
70 # if old style rpm dir exist, go with it
71 echo $HOME/rpm; \
72 elif [ -x ../builder -a ! -d ../builder ]; then
73 # relative new style rpmdir: in package dir
74 cd ..; pwd
75 elif [ -x builder -a ! -d builder ]; then
76 # relative new style rpmdir: in packages
77 pwd
78 elif [ -x packages/builder -a ! -d packages/builder ]; then
79 # relative new style rpmdir: packages dir in current dir
80 cd packages; pwd
81 else
82 # fallback to new style rpmdir
83 echo $HOME/rpm/packages
84 fi; \
85)}%_topdir
86
87# if %{_topdir}/SPECS exists, it's old style structure
88%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
89%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
90
91# BUILD/RPMS/SRPMS are on same level by default as packages dir, if these exist
92# if they don't exist assume we are having custom topdir (which is not named as
93# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
94# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therefore the extra echo
95%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
96%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
97%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
98
99# The number of cvs changelog entries kept when building package.
100%_buildchangelogtruncate 20
101
102%dependencytracking %{nil}
103
104# Relations between package names that cause dependency loops
105# with legacy packages that cannot be fixed. Relations are
106# specified as
107# p>q
108# where package p has a Requires: on something that package q Provides:
109#
110# XXX Note: that there cannot be any whitespace within the string "p>q",
111# and that both p and q are package names (i.e. no version/release).
112%_dependency_whiteout %{nil}
113
114#-----------------------------------------------------------------
115#
116# (re)definition of %{rpm*flags} with %filterout_* support
117# BuildRequires: awk
118# BuildRequires: rpmbuild(macros) >= 1.315
119#
120# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
121# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
122# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
123# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
124# %rpmldflags = %optldflags - %filterout_ld
125#
126# Regular expressions are supported, but to avoid some character be treated
127# as regular expression it must be escaped twice.
128
129%filter_out \
130 for (i = 1; i in I; i++) { A=0; \
131 for (f in F) { \
132 if (I[i] ~ "^" F[f] "$") A=1; \
133 }; \
134 if (!A) printf(I[i] FS); \
135 }
136
137%rpmcflags %(awk 'BEGIN {
138 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
139 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
140 %{filter_out}
141}')
142
143%rpmcxxflags %(awk 'BEGIN {
144 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
145 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
146 %{filter_out}
147}')
148
149%rpmcppflags %(awk 'BEGIN {
150 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
151 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
152 %{filter_out}
153}')
154
155%rpmldflags %(awk 'BEGIN {
156 split("%{?optldflags}",I);
157 split("%{?filterout_ld}",F)
158 %{filter_out}
159}')
160
161# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
162# but, don't use it, better use gcc as linker
163%ld_rpmldflags %(awk 'BEGIN {
164 split("%{rpmldflags}",F);
165 for (f in F) {
166 s = F[f];
167 if (s ~ /^-Wl,/) {
168 s = substr(s,5);
169 gsub(/,/," ",s);
170 };
171 printf(s FS);
172 };
173}')
174
175#-----------------------------------------------------------------
176#
177# Generate a command which cleans environment, leaving only the
178# most important variables.
179# If any spec requires any additional environment it should
180# redefine %_preserve_env in following manner:
181#
182# # ADDITIONAL_VAR is required because [a good reason here]
183# %define _preserve_env ADDITIONAL_VAR
184
185%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
186
187# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
188%_clean_env env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
189 split("%{?_preserve_env:%_preserve_env %_preserve_env_base}%{!?_preserve_env:%_preserve_env_base}", P);
190 for (i in P) {
191 p = P[i];
192 if (!ENVIRON[p] || d[p]) {
193 continue;
194 }
195 d[p] = 1;
196 split(ENVIRON[p], V, "");
197 val = p "=";
198 for (j = 1; j in V; j++) {
199 v = V[j];
200 if (v == q)
201 v = qq;
202 else if (v == "\\"")
203 v = q2q;
204 else if (v == "\\\\")
205 v = "\\\\\\\\";
206 else
207 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
208 val = val "" v;
209 }
210 printf(val " ");
211 }
212}')
213
214# override %__spec_build_pre and %__spec_install_pre from macros.rpmbuild
215# adding %{_clean_env}
216%__spec_build_pre %{_clean_env}\
217%{___build_pre}\
218%{nil}
219%__spec_install_pre %{_clean_env}\
220%{___build_pre}\
221%{?buildroot:%{__rm} -rf '%{buildroot}'; %{__mkdir_p} '%{buildroot}'}\
222%{nil}
223
224#-----------------------------------------------------------------
225%configure2_13 { \
226 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
227 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
228 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
229 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
230 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
231 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
232 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
233 %{?__cc:CC="%{__cc}" ; export CC ; } \
234 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
235 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
236 --host=%{_target_platform} \
237 --prefix=%{_prefix} \
238 --exec-prefix=%{_exec_prefix} \
239 --bindir=%{_bindir} \
240 --sbindir=%{_sbindir} \
241 --sysconfdir=%{_sysconfdir} \
242 --datadir=%{_datadir} \
243 --includedir=%{_includedir} \
244 --libdir=%{_libdir} \
245 --libexecdir=%{_libexecdir} \
246 --localstatedir=%{_localstatedir} \
247 --sharedstatedir=%{_sharedstatedir} \
248 --mandir=%{_mandir} \
249 --infodir=%{_infodir} \
250 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
251 %{dependencytracking} \
252}
253
254# Note: pass only standard cmake macros here.
255# The only exception is SYSCONF_INSTALL_DIR, used commonly in KDE packages,
256# where the default (${CMAKE_INSTALL_PREFIX}/etc) is not FHS-compliant and
257# absolute path MUST be used to comply with FHS.
258# The other non-standard cmake macros used commonly in KDE
259# (INCLUDE_INSTALL_DIR, LIB_INSTALL_DIR, SHARE_INSTALL_PREFIX)
260# have sane default values in KDE, and some packages use these names
261# in different way (e.g. expect them to be always relative or always
262# absolute).
263%cmake \
264%{?__cc:CC="${CC:-%{__cc}}"} \\\
265%{?__cxx:CXX="${CXX:-%{__cxx}}"} \\\
266CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
267%{__cmake} \\\
268 -DCMAKE_VERBOSE_MAKEFILE=ON \\\
269 -DCMAKE_BUILD_TYPE=%{!?debug:PLD}%{?debug:Debug} \\\
270 -DCMAKE_INSTALL_BINDIR:PATH=%{_bindir} \\\
271 -DCMAKE_INSTALL_SBINDIR:PATH=%{_sbindir} \\\
272 -DCMAKE_INSTALL_LIBEXECDIR:PATH=%{_libexecdir} \\\
273 -DCMAKE_INSTALL_SYSCONFDIR:PATH=%{_sysconfdir} \\\
274 -DCMAKE_INSTALL_SHAREDSTATEDIRPATH:PATH=%{_sharedstatedir} \\\
275 -DCMAKE_INSTALL_LOCALSTATEDIRPATH:PATH=%{_localstatedir} \\\
276 -DCMAKE_INSTALL_LIBDIR:PATH=%{_libdir} \\\
277 -DCMAKE_INSTALL_INCLUDEDIR:PATH=%{_includedir} \\\
278 -DCMAKE_INSTALL_OLDINCLUDEDIR:PATH=%{_includedir} \\\
279 -DCMAKE_INSTALL_DATAROOTDIR:PATH=%{_datadir} \\\
280 -DCMAKE_INSTALL_DATADIR:PATH=%{_datadir} \\\
281 -DCMAKE_INSTALL_INFODIR:PATH=%{_infodir} \\\
282 -DCMAKE_INSTALL_LOCALEDIR:PATH=%{_localedir} \\\
283 -DCMAKE_INSTALL_MANDIR:PATH=%{_mandir} \\\
284 -DCMAKE_INSTALL_DOCDIR:PATH=%{_docdir} \\\
285 -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \\\
286 -DSYSCONF_INSTALL_DIR:PATH=%{_sysconfdir} \\\
287 -DCMAKE_CXX_FLAGS_PLD="${CXXFLAGS:-%{rpmcxxflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
288 -DCMAKE_C_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
289 -DCMAKE_Fortran_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
290 -DCMAKE_EXE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
291 -DCMAKE_SHARED_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
292 -DCMAKE_MODULE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
293%if "%{_lib}" == "lib64" \
294 -DLIB_SUFFIX=64 \\\
295%endif \
296%if "%{_lib}" == "libx32" \
297 -DLIB_SUFFIX=x32 \\\
298%endif \
299 -DBUILD_SHARED_LIBS:BOOL=ON \\\
300%{nil}
301
302%scons { \
303%{__scons} \
304 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
305 CFLAGS="${CFLAGS:-%rpmcflags}" \
306 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
307 FFLAGS="${FFLAGS:-%rpmcflags}" \
308 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
309 %{?__cc:CC="%{__cc}"} \
310 %{?__cxx:CXX="%{__cxx}"} \
311 libsuffix=%{_lib} \
312 prefix=%{_prefix} \
313}
314
315# waf. see waf.spec
316%waf { \
317CC="%{__cc}" \
318CXX="%{__cxx}" \
319CPP="%{__cpp}" \
320CFLAGS="%{rpmcflags}" \
321CXXFLAGS="%{rpmcxxflags}" \
322LINKFLAGS="%{rpmldflags}" \
323%{__waf} \
324}
325
326# meson
327%meson { \
328%{?__cc:CC="${CC:-%{__cc}}"} \
329%{?__cxx:CXX="${CXX:-%{__cxx}}"} \
330CFLAGS="${CFLAGS:-%{rpmcflags}}" \
331CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \
332CXXFLAGS="${CXXFLAGS:-%{rpmcxxflags}}" \
333LDFLAGS="${LDFLAGS:-%{rpmldflags}}" \
334LC_ALL=C.UTF-8 %{__meson} \
335 --buildtype=plain \
336 --bindir=%{_bindir} \
337 --datadir=%{_datadir} \
338 --includedir=%{_includedir} \
339 --infodir=%{_infodir} \
340 --libdir=%{_libdir} \
341 --libexecdir=%{_libexecdir} \
342 --localedir=%{_localedir} \
343 --localstatedir=%{_localstatedir} \
344 --mandir=%{_mandir} \
345 --prefix=%{_prefix} \
346 --sbindir=%{_sbindir} \
347 --sharedstatedir=%{_sharedstatedir} \
348 --sysconfdir=%{_sysconfdir} \
349 --wrap-mode=%{__meson_wrap_mode} \
350 --default-library='both' \
351}
352
353%___meson_deprecate() {echo >&2 "DEPRECATED: %%%1 must be replaced with %%%2"; %{expand:%%%2} }
354%meson_build %___meson_deprecate meson_build ninja_build
355%meson_install %___meson_deprecate meson_install ninja_install
356%meson_test %___meson_deprecate meson_test ninja_test
357
358# ninja
359%ninja_build LC_ALL=C.UTF-8 %{__ninja} %{__ninja_common_opts}
360%ninja_install LC_ALL=C.UTF-8 DESTDIR=%{buildroot} %{__ninja} install %{__ninja_common_opts}
361%ninja_test LC_ALL=C.UTF-8 %{__ninja} test %{__ninja_common_opts}
362
363#----------------------------------------------------------------
364#%configure_cache 0
365%configure_cache_file %{buildroot}.configure.cache
366
367%configure {./configure \
368 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
369 CFLAGS="${CFLAGS:-%rpmcflags}" \
370 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
371 FFLAGS="${FFLAGS:-%rpmcflags}" \
372 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
373 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
374 %{?__cc:CC="%{__cc}"} \
375 %{?__cxx:CXX="%{__cxx}"} \
376 --host=%{_target_platform} \
377 --build=%{_target_platform} \
378 --prefix=%{_prefix} \
379 --exec-prefix=%{_exec_prefix} \
380 --bindir=%{_bindir} \
381 --sbindir=%{_sbindir} \
382 --sysconfdir=%{_sysconfdir} \
383 --datadir=%{_datadir} \
384 --includedir=%{_includedir} \
385 --libdir=%{_libdir} \
386 --libexecdir=%{_libexecdir} \
387 --localstatedir=%{_localstatedir} \
388 --sharedstatedir=%{_sharedstatedir} \
389 --mandir=%{_mandir} \
390 --infodir=%{_infodir} \
391 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
392 %{dependencytracking} \
393 %{?configure_cache:--cache-file=%{configure_cache_file}} \
394}
395
396# Simple macros to simplify adding bconded options to configure scripts.
397# Each macro requires bcond name and accepts optional option name, if option
398# isn't specified bcond name is used as option name. Options returning
399# --with and --enable also allow third argument which will be added as value
400# ( --with-option=value or --enable-option=value ) in case or positive
401# condition, but won't be added otherwise ( nothing or just --disable-option ).
402
403# Requirements:
404# BuildRequires: rpmbuild(macros) >= 1.527
405
406# Usage example:
407# %{__enable bcond} - returns --enable-bcond iff build condition is set
408# %{__disable bcond option} - returns --enable-option iff bcond is not set
409# %{__enable_disable bcond option value} - returns --enable-option=value if
410# bcond is set, returns --disable-option otherwise
411
412# expand bconds to --enable-something and --disable-something
413%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
414%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
415%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
416
417# same as above, but condition inverted
418%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
419%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
420%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
421
422# expand bconds to --with-something and --without-something
423%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
424%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
425%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
426
427# same as above, but condition inverted
428%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
429%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
430%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
431
432# expands to true or false based on bcond; for use with meson or cmake
433%__true_false() %{expand:%%{?with_%{1}:true}%%{!?with_%{1}:false}}
434%__true_false_not() %{expand:%%{?with_%{1}:false}%%{!?with_%{1}:true}}
435
436# for use with cmake:
437# Usage: cmake_on_off BCOND_NAME [OPTION_NAME]
438# BuildRequires: rpmbuild(macros) >= 1.742
439%cmake_on_off() -D%{?2}%{!?2:%{1}}:BOOL=%{expand:%%{?with_%{1}:ON}%%{!?with_%{1}:OFF}}
440
441#-----------------------------------------------------------------
442
443# overload to insert debuginfo package
444%prep \
445%if 0%{?_enable_debug_packages}\
446%{debug_package}\
447%endif\
448%%prep\
449%{nil}
450
451# Location of autoconf macros
452%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
453
454# Location of omf files
455%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
456
457# Location of pkgconfig files
458%_pkgconfigdir /usr/%{_lib}/pkgconfig
459# noarch pkgconfig files
460%_npkgconfigdir /usr/share/pkgconfig
461
462# Location of desktop files
463%_desktopdir /usr/share/applications
464%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
465
466# Location of pixmaps for applnk/desktop files
467%_pixmapsdir /usr/share/pixmaps
468
469# Location of themable icons for applnk/desktop files
470%_iconsdir /usr/share/icons
471
472# Location of fonts directories
473%_fontsdir /usr/share/fonts
474
475# Location of Gtk and associated libraries documentation
476%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
477
478# Location of KDE documentation
479%_kdedocdir %{_defaultdocdir}/kde/HTML
480
481# unsermake script
482%__unsermake /usr/share/unsermake/unsermake
483
484# Current date
485%date %(LC_ALL=C date +"%a %b %d %Y")
486
487# Example files, programs, scripts...
488%_examplesdir /usr/src/examples
489
490# SysV-style initscripts dir
491%_initddir /etc/rc.d/init.d
492
493# If non-empty "debug" macro defined, add "dbg" suffix to release number
494%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
495
496# Bootstrap release macros.
497# Usage:
498# %bcond_with bootstrap
499# Release: %{bootstrap_release 1}
500#
501# Package will have release 1 if built normally,
502# and release 0.zzz.bootstrap if built with bootstrap
503%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
504
505# Requires name = version-release
506%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
507# Requires: name = version
508%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
509# Requires: name = version (version based on querying package %2)
510%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
511
512# Requires: name >= version
513%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
514# Requires: name >= version (version based on querying package %2)
515%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
516
517# helper for renaming packages
518# %rename old-package
519%rename() \
520Obsoletes: %{1} < %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}} \
521Provides: %{1} = %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}}
522
523%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
524
525# sgml macros
526%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
527%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
528%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
529%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
530%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
531%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
532%docbook_sgmlcat_fix() { for l in \
533'' \
534' -- default decl --' \
535'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
536' -- hacks for opensp --' \
537'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
538'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
539'' \
540; do echo $l; done >> %1 \
541}
542
543# vim - "
544
545# minimum file size needed for compressed documents.
546# just smaller files than this get larger when compressed.
547# some stats:
548# - 0 byte file compressed was 25 bytes .gz
549# - 39 byte file was compressed as 57
550# - with test/test.spec@man 158 byte file was compressed also 158
551%_min_compress_bytes 159
552
553#-----------------------------------------------------------------
554# find and gzip all files in %{_mandir} and %{infodir}
555#
556# Requires: xargs, find
557#
558#%no_install_post_compress_docs 1
559%__spec_install_post_compress_docs { \
560%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
561 %{!?debug:set +x;} \
562 for i in /usr/share/man /usr/X11R6/man; do \
563 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
564 echo "Compress man pages: $i"; \
565 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print0 | xargs -0 -r %{__bzip2} -df; \
566 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print0 | xargs -0 -r %{__gzip} -dnf; \
567 find $RPM_BUILD_ROOT$i -type l | while read a; do \
568 m=$(readlink "$a"); \
569 if [[ "$m" = */* ]]; then \
570 # handle links to different man section \
571 l=$(readlink -f "$a"); \
572 # full/relative paths that resolve symlink \
573 l=${l#$RPM_BUILD_ROOT/usr/share/man/}; \
574 l=${l#$RPM_BUILD_ROOT/usr/X11R6/man/}; \
575 # full paths that do not resolve symlink \
576 l=${l#/usr/share/man/}; \
577 l=${l#/usr/X11R6/man/}; \
578 else \
579 l=${a#$RPM_BUILD_ROOT$i/}; \
580 l=${l%/*}; \
581 l="$l/$m"; \
582 fi; \
583 rm -f $a; \
584 echo ".so $l" > $a; \
585 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: $l"; \
586 done; \
587 # verify that .so links point to existing files (not allowed to point to "other package") \
588 # TODO: iterate over all man dirs, but in Th there is only one true man dir \
589 err=$(grep -rl '^\.so ' "$RPM_BUILD_ROOT$i" | while read doc; do \
590 l=$(grep -r '^\.so ' "$doc"); \
591 l=${l#.so }; \
592 d=$(dirname $doc); \
593 test -e $RPM_BUILD_ROOT$i/$l || test -e $d/$(basename $l) || echo " ${doc#$RPM_BUILD_ROOT} points to inexistent manpage: $l"; \
594 done); \
595 test "$err" != "" && { echo >&2 "Man page link errors:"; echo >&2 "$err"; exit 1; }; \
596 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print0 | xargs -0 -r %{__gzip} -9nf; \
597 fi; \
598 done; \
599 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
600 echo "Compress info pages: %{_infodir}"; \
601 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print0 | xargs -0 -r %{__bzip2} -df; \
602 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print0 | xargs -0 -r %{__gzip} -dnf; \
603 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print0 | xargs -0 -r %{__gzip} -9nf; \
604 fi; \
605}; __spec_install_post_compress_docs } }
606
607#-----------------------------------------------------------------
608# Strip executable binaries and shared object files
609#
610# Requires: find, awk, strip, cut, xargs
611#
612# Special macros which affect this process:
613#%no_install_post_strip 1 # disable stripping at all
614#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
615#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
616#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
617#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
618#
619%__spec_install_post_strip {%{!?debug: \
620%{!?no_install_post_strip:__spec_install_post_strip() { \
621%{!?debug:set +x;} \
622if [ -d "$RPM_BUILD_ROOT" ]; then \
623 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
624 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
625 if [ "$modulelist" ]; then \
626 modulecount=$(echo "$modulelist" | wc -l); \
627 printf "Stripping %d kernel modules..." $modulecount; \
628 echo "$modulelist" | xargs -l512 chmod u+w; \
629 echo "$modulelist" | xargs -l512 %{__strip} -g --remove-section=.comment --remove-section=.note.GNU-stack; \
630 echo "DONE"; \
631 fi; \
632 fi; \
633 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[x0-9]*/debug/.*\.debug" ! -regex ".*/usr/lib[x0-9]*.*/guile/.*\.go" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
634 if [ -n "$filelist" ]; then \
635 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
636 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
637 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
638 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
639 if [ -n "$elfexelist" ]; then \
640 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
641 echo "$elfexelist" | xargs -r -d'\n' chmod u+w; \
642 echo "$elfexelist" | xargs -r -d'\n' %{__strip} --remove-section=.note --remove-section=.comment; \
643 echo "DONE"; \
644 fi; \
645 if [ -n "$elfsharedlist" ]; then \
646 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
647 echo "$elfsharedlist" | xargs -r -d'\n' chmod u+w; \
648 echo "$elfsharedlist" | xargs -r -d'\n' %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment; \
649 echo "DONE"; \
650 fi; \
651 if [ -n "$archiveslist" ]; then \
652 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
653 echo "$archiveslist" | xargs -r -d'\n' chmod u+w; \
654 echo "$archiveslist" | xargs -r -d'\n' %{__strip} --strip-debug --remove-section=.note --remove-section=.comment; \
655 echo "DONE"; \
656 fi; \
657 fi; \
658 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
659 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
660 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
661 if [ -n "$filelist_all" ]; then \
662 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
663 chmod u+w $filelist_all; \
664 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
665 echo "DONE"; \
666 fi; \
667 if [ -n "$filelist_unneeded" ]; then \
668 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
669 chmod u+w $filelist_unneeded; \
670 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
671 echo "DONE"; \
672 fi; \
673 if [ -n "$filelist_debug" ]; then \
674 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
675 chmod u+w $filelist_debug; \
676 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
677 echo "DONE"; \
678 fi; \
679fi; }; __spec_install_post_strip } } }
680
681#-----------------------------------------------------------------
682# remove all RPATH/RUNPATH from executable binaries and shared object files
683#
684# Requires: find, awk, cut, xargs, chrpath, uname
685#
686# Special macros which affect this process
687#%no_install_post_chrpath 1 # disable chrpath at all
688#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
689#
690%__spec_install_post_chrpath {%{!?debug: \
691%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
692%{!?debug:set +x;} \
693if [ -d "$RPM_BUILD_ROOT" ]; then \
694 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
695 if [ -n "$files" ]; then \
696 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
697 fi; \
698 if [ -n "$objs" ]; then \
699 printf "Remove RPATH/RUNPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
700 echo "$objs" | \
701 while read file; do \
702 rpath= ; \
703 chmod u+w "$file"; \
704 for dir in $(chrpath -l "$file" | awk '/(R|RUN)PATH=/ { gsub(/.*RPATH=/,""); gsub(/.*RUNPATH=/,""); gsub(/:/," "); print $0 }'); do \
705 case $dir in \
706 '$ORIGIN' ) \
707 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
708 else rpath="$rpath:$dir" ; fi ; \
709 continue ; \
710 ;; \
711 esac ; \
712 newdir=$(readlink -m "$dir"); \
713 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
714 case $dir in \
715 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
716 echo "remove-rpath: $dir in $file"; \
717 ;; \
718 * ) \
719 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
720 else rpath="$rpath:$dir" ; fi ; \
721 ;; \
722 esac ; \
723 done ; \
724 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
725 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
726 done; \
727 fi; \
728fi; }; __spec_install_post_chrpath } } }
729
730# vim: "
731
732#-----------------------------------------------------------------
733# Find all shared object files with unresolved symbols. Warn
734# and terminate if any found (termination can be turned off by define).
735#%no_install_post_check_so 1
736#%skip_post_check_so libwithunresolvedok.so.*
737#
738# NOTE: define skip_post_check_so only if such library really requires
739# unresolved symbols and always leave a comment why it is required:
740# # executable provides symbols foo, bar for those libraries:
741# %define skip_post_check_so libwithoutfoo.so.* libwithoutbar.so.*
742#
743%__spec_install_post_check_so { \
744__spec_install_post_check_so() { \
745%{!?debug:set +x;} \
746 fail=0; \
747 printf "Searching for shared objects with unresolved symbols..."; \
748 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
749 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; skip["_ZSt15__once_callable"]=1; skip["_ZSt11__once_call"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; %{?skip_post_check_so:split("%{skip_post_check_so}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "Library marked with skip_post_check_so, ignoring errors.\n"; exit(0); } } } exit(1); } } ' || fail=1 ; \
750 done ; \
751 echo " DONE"; \
752 %{!?no_install_post_check_so:return $fail;} \
753}; __spec_install_post_check_so }}
754
755#-----------------------------------------------------------------
756# Find all ELF files with executable stac. Warn and terminate if any found
757# (termination can be turned off by define).
758# Details: https://wiki.gentoo.org/wiki/Hardened/GNU_stack_quickstart
759#%no_install_post_check_stackexec 1
760#%skip_post_check_stackexec libwithexecstackok.so.*
761#
762# NOTE: define skip_post_check_stackexec only if such program or library
763# really requires executable stack and always leave a comment why
764# it is required:
765# # Programs full of nested functions that cannot be fixed
766# %define skip_post_check_execstack /bin/foo libwithexecstack.so.*
767#
768%__spec_install_post_check_execstack { \
769__spec_install_post_check_execstack() { \
770%{!?debug:set +x;} \
771 fail=0; \
772 printf "Searching for ELF programs with executable stack..."; \
773 for f in $(find $RPM_BUILD_ROOT -type f -print) ; do \
774 LC_ALL=C readelf -lW $f 2>/dev/null | \
775 LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; } /GNU_STACK/ { if ($7 ~ "E") { found=1 } } END { if (found) { print "\nExecutable stack found in: " file; %{?skip_post_check_execstack:split("%{skip_post_check_execstack}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "File marked with skip_post_check_execstack, ignoring errors.\n"; exit(0); } } } exit(1); } }' || fail=1 ; \
776 done ; \
777 echo " DONE"; \
778 %{!?no_install_post_check_execstack:return $fail;} \
779}; __spec_install_post_check_execstack }}
780
781#-----------------------------------------------------------------
782# Verify that for each directory under /var/run package contains
783# tmpfiles.d configuration. Warn and terminate build if config is
784# missing.
785#
786#%no_install_post_check_tmpfiles 1
787#
788%__spec_install_post_check_tmpfiles { \
789__spec_install_post_check_tmpfiles() { \
790%{!?debug:set +x;} \
791 fail=0; \
792 echo "Checking /var/run <-> tmpfiles.d completeness..."; \
793 for d in $RPM_BUILD_ROOT/var/run/*; do \
794 [ -d "$d" ] || continue; \
795 d=${d##$RPM_BUILD_ROOT}; \
796 if ! grep -qsF "$d" $RPM_BUILD_ROOT/usr/lib/tmpfiles.d/*.conf $RPM_BUILD_ROOT/etc/tmpfiles.d/*.conf; then\
797 echo "No tmpfiles configuration for '$d'";\
798 fail=1 ; \
799 fi \
800 done ; \
801 echo " DONE"; \
802 %{!?no_install_post_check_tmpfiles:return $fail;} \
803}; __spec_install_post_check_tmpfiles }}
804
805#-----------------------------------------------------------------
806# Verify that scripts have reasonable shebangs
807# Test spec: see "test/spec_install_post_check_shebangs" branch on packages/test.spec
808#
809#%no_install_post_check_shebangs 1
810#
811%__spec_install_post_check_shebangs { \
812__spec_install_post_check_shebangs() { \
813%{!?debug:set +x;} \
814 fail=0; \
815 echo "Checking script shebangs..."; \
816 find $RPM_BUILD_ROOT -type f -perm -500 -print | \
817 while read f ; do \
818 shebang="$(sed -e'1s/#! *\(.*\)/\1/;t;d;q' "$f")" ; \
819 f="${f##$RPM_BUILD_ROOT}"; \
820 case "$shebang" in \
821 "%{__python}"|"%{__python3}"|"%{__python} "*|"%{__python3} "* \
822 |"/usr/bin/python%{py_ver}"|"/usr/bin/python%{py_ver} "* \
823 |"/usr/bin/python%{py3_ver}"|"/usr/bin/python%{py3_ver} "*) \
824 ;; \
825 "/usr/bin/env python"*|"/usr/bin/python"|"/usr/bin/python "*) \
826 echo "$f starts with '#!$shebang', should be '#!%{__python}' or '#!%{__python3}'" >&2;\
827 fail=1 ; \
828 ;; \
829 "/usr/bin/env "*) \
830 echo "$f starts with '#!$shebang', should be explicit interpreter path" >&2;\
831 fail=1 ; \
832 ;; \
833 *) ;;\
834 esac ; \
835 done ; \
836 echo " DONE" ; \
837}; %{!?no_install_post_check_shebangs:__spec_install_post_check_shebangs} }
838
839# Remove common Perl files we don't package
840%__spec_install_post_perl_clean {\
841%{!?no_install_post_perl_clean: \
842%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
843} }
844
845# Helpers to specify SONAME depdendencies, e.g.:
846# Requires: %{_soname_prov libfoo.so.1}
847# Requires: %{_soname_prov libfoo.so.1(SOME_SYMVER)}
848#
849# BuildRequires: rpmbuild(macros) >= 1.721
850#
851%_soname_tag %(echo %{_lib} | sed -e 's/^lib//' -e 's/^\\(.\\+\\)$/(\\1bit)/')
852%_soname_prov() %(echo "%{1}()%{_soname_tag}" | sed -e 's/^\\([^(]*([^)]\\+)\\)()%{_soname_tag}$/\\1%{_soname_tag}/;s/()$//')
853
854#-----------------------------------------------------------------
855# Update GConf2 schemas
856#
857# Requires: GConf2
858#
859%gconf_schema_install() \
860 umask 022; \
861 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
862 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
863%{nil}
864
865%gconf_schema_uninstall() \
866if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
867 umask 022; \
868 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
869 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
870fi; \
871%{nil}
872
873#-----------------------------------------------------------------
874# Update desktop MIME database
875# requires: desktop-file-utils
876%update_desktop_database() {{ \
877 umask 022; \
878 /usr/bin/update-desktop-database -q; \
879};} \
880%{nil}
881
882%update_desktop_database_post %update_desktop_database
883
884%update_desktop_database_postun() {{ \
885if [ "$1" = "0" ]; then \
886 %update_desktop_database \
887fi; \
888};} \
889%{nil}
890
891#-----------------------------------------------------------------
892# Update shared MIME info database
893# requires: shared-mime-info
894# Note: https://bugs.freedesktop.org/show_bug.cgi?id=70366#c19
895# https://bugzilla.redhat.com/show_bug.cgi?id=1052173
896# TODO: if you want this running with fdatasync(), make sure it's:
897# 1. announcing ~minute delay by echoing appropriate message,
898# 2. running only once after rpm transaction.
899#
900%update_mime_database() {{ \
901 umask 022; \
902 PKGSYSTEM_ENABLE_FSYNC=0 \
903 /usr/bin/update-mime-database %{_datadir}/mime; \
904};} \
905%{nil}
906
907#-----------------------------------------------------------------
908# Update icon cache
909# BuildRequires: rpmbuild(macros) >= 1.596
910# Requires: hicolor-icon-theme
911#
912%update_icon_cache() {{ \
913 %{!?1:%{error:%{0}: Required theme name missing}} \
914 if [ -x /usr/bin/gtk-update-icon-cache ]; then \
915 umask 022; \
916 touch --no-create %{_iconsdir}/%1; \
917 /usr/bin/gtk-update-icon-cache -qf %{_iconsdir}/%1; \
918 fi; \
919};} \
920%{nil}
921
922#-----------------------------------------------------------------
923# Update scrollkeeper database
924# requires: scrollkeeper
925#
926%scrollkeeper_update_post() \
927 /usr/bin/scrollkeeper-update -q; \
928%{nil}
929
930%scrollkeeper_update_postun() \
931if [ "$1" = "0" ]; then \
932 /usr/bin/scrollkeeper-update -q; \
933fi; \
934%{nil}
935
936#-----------------------------------------------------------------
937# Compile GSettings schemas
938# requires: glib2 >= 1:2.26.0
939#
940%glib_compile_schemas() {{ \
941 umask 022; \
942 /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas; \
943};} \
944%{nil}
945
946#-----------------------------------------------------------------
947# post %install sequence:
948# - autodeps exceptions
949# - compress all man and info pages,
950# - strip all ELF executables and ELF shared objects if not %debug.
951# - compress kernel modules if any
952
953###################################################################
954# Requires/Provides automation
955# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
956#
957%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
958%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
959%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
960%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov) \
961 %{?_noautoprov: %{_noautoprov}} \
962 %{?_noautoprov_java: %{__noauto_regexp_helper -p java %{_noautoprov_java}}} \
963 %{?_noautoprov_mono: %{__noauto_regexp_helper -p mono %{_noautoprov_mono}}} \
964 %{?_noautoprov_pear: %{__noauto_regexp_helper -p pear %{_noautoprov_pear}}} \
965 %{?_noautoprov_perl: %{__noauto_regexp_helper -p perl %{_noautoprov_perl}}} \
966 %{?_noautoprov_pyegg: %{__noauto_regexp_helper -p pythonegg %{_noautoprov_pyegg}}} \
967 %{?_noautoprov_py3egg: %{__noauto_regexp_helper -p python3egg %{_noautoprov_py3egg}}} \
968 %{nil}
969%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq) \
970 %{?_noautoreq: %{_noautoreq}} \
971 %{?_noautoreq_java: %{__noauto_regexp_helper -p java %{_noautoreq_java}}} \
972 %{?_noautoreq_mono: %{__noauto_regexp_helper -p mono %{_noautoreq_mono}}} \
973 %{?_noautoreq_pear: %{__noauto_regexp_helper -p pear %{_noautoreq_pear}}} \
974 %{?_noautoreq_perl: %{__noauto_regexp_helper -p perl %{_noautoreq_perl}}} \
975 %{?_noautoreq_pyegg: %{__noauto_regexp_helper -p pythonegg %{_noautoreq_pyegg}}} \
976 %{?_noautoreq_py3egg: %{__noauto_regexp_helper -p python3egg %{_noautoreq_py3egg}}} \
977 %{nil}
978
979# helper for wrapping _noautoreq between perl() or pear()
980# Author: Elan Ruusamäe <glen@pld-linux.org>
981# Usage:
982# BuildRequires: rpmbuild(macros) >= 1.654
983# %define _noautoreq_pear Excluded.php PEAR/Something.php
984# %define _noautoreq_perl Apache::.*
985# BuildRequires: rpmbuild(macros) >= 1.672
986# %define _noautoreq_java ClassDataVersion
987# BuildRequires: rpmbuild(macros) >= 1.709
988# %define _noautoreq_pyegg argparse
989# %define _noautoreq_py3egg backports.ssl-match-hostname ipaddress
990# BuildRequires: rpmbuild(macros) >= 1.730
991# %define _noautoreq_mono Gendarme.Framework
992# BuildRequires: rpmbuild(macros) >= 1.737
993# %define _noautoprov_java Class
994# %define _noautoprov_mono Excluded.Provide
995# %define _noautoprov_pear Excluded.php
996# %define _noautoprov_perl Excluded::Module
997# %define _noautoprov_pyegg excluded
998# %define _noautoprov_py3egg excluded3
999#
1000%__noauto_regexp_helper(p:) %(echo "%*" | awk 'BEGIN{RS=" "}{printf("%{-p*}%{__qchar}(%%s%{__qchar}) ", $1)}')
1001# detect quote character runtime
1002%__qchar_4 \\\\%{nil}
1003%__qchar_5 \\\\\\%{nil}
1004%__qchar %{expand:%%global __qchar %%__qchar_%(echo %{_rpmversion} | cut -c1)}%__qchar
1005
1006#%_noautocompressdoc %{nil}
1007#
1008%_missing_doc_files_terminate_build 1%{nil}
1009%_unpackaged_files_terminate_build %{nil}
1010# (X)emacs support
1011%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
1012%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
1013%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
1014
1015%__php_provides %{nil}
1016%__php_requires %{nil}
1017%__perl_provides %{nil}
1018%__perl_requires %{nil}
1019%__mono_provides %{nil}
1020%__mono_requires %{nil}
1021
1022# Perl specific macro definitions.
1023%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
1024%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
1025%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
1026%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
1027%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
1028%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
1029
1030# Ruby
1031%__ruby /usr/bin/ruby
1032
1033# Ruby ABI version
1034# NOTE: %ruby_version may be empty, depending how Ruby was built
1035%ruby_abi %{expand:%%global ruby_abi %(%{__ruby} -r rbconfig -e 'print [RbConfig::CONFIG["MAJOR"], RbConfig::CONFIG["MINOR"]].join(".")' 2>/dev/null || echo ERROR)}%ruby_abi
1036
1037# get rbconfig parameter
1038%__ruby_rbconfig() %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["%1"]' 2>/dev/null || echo ERROR)
1039%__ruby_rbconfig_path() %(%{__ruby} -r rbconfig -r pathname -e 'print Pathname(RbConfig::CONFIG["%1"]).cleanpath' 2>/dev/null || echo ERROR)
1040
1041%ruby_archdir %{expand:%%global ruby_archdir %{__ruby_rbconfig_path archdir}}%ruby_archdir
1042%ruby_libdir %{expand:%%global ruby_libdir %{__ruby_rbconfig rubylibdir}}%ruby_libdir
1043%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'print File.join(RbConfig::CONFIG["datadir"], "ri", "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
1044%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %{__ruby_rbconfig_path rubylibdir}}%ruby_rubylibdir
1045%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %{__ruby_rbconfig vendorarchdir}}%ruby_vendorarchdir
1046%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %{__ruby_rbconfig_path vendorlibdir}}%ruby_vendorlibdir
1047%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %{__ruby_rbconfig sitearchdir}}%ruby_sitearchdir
1048%ruby_sitedir %{expand:%%global ruby_sitedir %{__ruby_rbconfig sitedir}}%ruby_sitedir
1049%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %{__ruby_rbconfig_path sitelibdir}}%ruby_sitelibdir
1050%ruby_rdocdir /usr/share/rdoc
1051%ruby_vendordir %{expand:%%global ruby_vendordir %{__ruby_rbconfig vendordir}}%ruby_vendordir
1052%ruby_version %{expand:%%global ruby_version %(r=%{__ruby_rbconfig ruby_version}; echo ${r:-%%nil})}%ruby_version
1053
1054%ruby_gemdir %{expand:%%global ruby_gemdir %(%{__ruby} -r rubygems -e 'puts Gem.respond_to?(:default_dirs) ? Gem.default_dirs[:system][:gem_dir] : Gem.path.first' 2>/dev/null || echo ERROR)}%{ruby_gemdir}
1055%ruby_specdir %{ruby_gemdir}/specifications
1056
1057# deprecated, ruby 2.0 noarch packages are versionless and extension dependency is generated by rpm5
1058%ruby_ver_requires_eq %{nil}
1059%ruby_mod_ver_requires_eq %{nil}
1060
1061%php_pear_dir /usr/share/pear
1062%php_data_dir /usr/share/php
1063%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
1064%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
1065%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
1066
1067# extract php/zend api versions
1068%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
1069%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
1070%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
1071%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
1072%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
1073%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
1074%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
1075%_zend_zts %{expand:%%global _zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%_zend_zts
1076# "_ts" if ZTS enabled, empty otherwise
1077%zend_zts %{expand:%%global _zend_zts_%{?_zend_zts} 1}%{?_zend_zts_1:_ts}
1078
1079# name of php package
1080%php_name php%{?php_suffix}
1081# use rpmbuild -D 'php_suffix 54' to build php extension for php 5.4
1082# NOTE: error output must be empty. otherwise can't build pecl packages if no php*-devel is installed
1083%php_suffix %{expand:%%global php_suffix %(c=$(php-config --sysconfdir 2>/dev/null) || echo '' && echo ${c#/etc/php})%%{nil}}%php_suffix
1084
1085# phpXY, version always present for using current php version (in regards of php*-devel package)
1086%php_versuffix %{expand:%%global php_versuffix %((IFS=.; set -- $(php-config --version); echo $1$2))%%{nil}}%php_versuffix
1087
1088# php cli. version that php headers are installed for
1089%__php /usr/bin/php%{php_versuffix}
1090
1091# helper macro
1092%__php_api_requires() Requires: %{php_name}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
1093
1094# macros for public use
1095# for php extensions (php-pecl)
1096%requires_php_extension %{__php_api_requires modules_api php_api_version} \
1097%{__php_api_requires zend_module_api} \
1098%{__php_api_requires debug php_debug} \
1099%{__php_api_requires thread-safety _zend_zts}
1100
1101# for zend extensions
1102%requires_zend_extension %{__php_api_requires zend_module_api} \
1103%{__php_api_requires zend_extension_api} \
1104%{__php_api_requires debug php_debug} \
1105%{__php_api_requires thread-safety _zend_zts}
1106
1107# for php pdo modules (php-pecl-PDO_*)
1108%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
1109
1110# for using PHP post scripts. for PHP >= 5.0
1111%php_webserver_restart \
1112[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
1113[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
1114if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
1115 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
1116 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
1117 %service -q php-fcgi restart \
1118 fi \
1119fi \
1120if [ -x /etc/rc.d/init.d/%{php_name}-fpm ]; then \
1121 %service -q %{php_name}-fpm restart \
1122fi \
1123%{nil}
1124
1125# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
1126%php4_webserver_restart \
1127[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
1128[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
1129if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
1130 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
1131 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
1132 %service -q php-fcgi restart \
1133 fi \
1134fi \
1135%{nil}
1136
1137# X.org helper macros
1138%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
1139%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
1140
1141%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
1142%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
1143%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
1144%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
1145%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
1146# vim: '
1147
1148%requires_xorg_xserver_extension \
1149%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1150%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1151%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
1152%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
1153%{nil}
1154
1155%requires_xorg_xserver_xinput \
1156%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1157%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1158%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
1159%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
1160%{nil}
1161
1162%requires_xorg_xserver_font \
1163%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1164%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1165%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
1166%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
1167%{nil}
1168
1169%requires_xorg_xserver_videodrv \
1170%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1171%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1172%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
1173%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
1174%{nil}
1175
1176# TCL specific macro definitions.
1177# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
1178%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
1179%tcl_sitearch %{_libdir}/tcl%{tcl_version}
1180%tcl_sitelib %{_datadir}/tcl%{tcl_version}
1181
1182# Python specific macro definitions.
1183# python main version
1184%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
1185
1186# directories
1187%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
1188%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
1189%py_scriptdir %{py_prefix}/share/python%{py_ver}
1190%py_incdir /usr/include/python%{py_ver}
1191%py_sitedir %{py_libdir}/site-packages
1192%py_sitescriptdir %{py_scriptdir}/site-packages
1193%py_dyndir %{py_libdir}/lib-dynload
1194
1195# pure python modules compilation
1196%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1197
1198%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1199
1200# Software written in Python language require Python with main version
1201%pyrequires_eq() Requires: %1
1202
1203# Python 3.x
1204# python main version
1205%__python3 /usr/bin/python3
1206%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
1207
1208# directories
1209%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
1210%py3_incdir %{expand:%%global py3_incdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('include'))" 2>/dev/null || echo ERROR)}%py3_incdir
1211%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
1212%py3_sitedir %{py3_libdir}/site-packages
1213%py3_sitescriptdir %{py3_prefix}/share/python%{py3_ver}/site-packages
1214%py3_dyndir %{py3_libdir}/lib-dynload
1215
1216# pure python modules compilation
1217%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1218
1219%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1220
1221%py_build { \
1222 LDFLAGS="${LDFLAGS:-%rpmldflags}"; export LDFLAGS; \
1223 CFLAGS="${CFLAGS:-%rpmcppflags %rpmcflags}"; export CFLAGS; \
1224 CXXFLAGS="${CXXFLAGS:-%rpmcppflags %rpmcxxflags}"; export CXXFLAGS; \
1225 %{?__cc:CC="%{__cc}"; export CC;} \
1226 %{?__cxx:CXX="%{__cxx}"; export CXX;} \
1227 %{__python} setup.py \
1228 build --build-base=build-2 \
1229}
1230
1231# "shrink" filter to keep this macro without newlines,
1232# so it could be used as make arguments
1233%py_install_opts() %{shrink: \
1234 --prefix=%{_prefix} \
1235 --install-purelib=%{py_sitescriptdir} \
1236 --install-platlib=%{py_sitedir} \
1237 --optimize=2 \
1238}
1239
1240%py_install { \
1241 LDFLAGS="${LDFLAGS:-%rpmldflags}"; export LDFLAGS; \
1242 CFLAGS="${CFLAGS:-%rpmcppflags %rpmcflags}"; export CFLAGS; \
1243 CXXFLAGS="${CXXFLAGS:-%rpmcppflags %rpmcxxflags}"; export CXXFLAGS; \
1244 %{?__cc:CC="%{__cc}"; export CC;} \
1245 %{?__cxx:CXX="%{__cxx}"; export CXX;} \
1246 %{__python} setup.py \
1247 build --build-base=build-2 \
1248 install --skip-build \
1249 %{py_install_opts} \
1250 --root=$RPM_BUILD_ROOT \
1251}
1252
1253%py3_build { \
1254 LDFLAGS="${LDFLAGS:-%rpmldflags}"; export LDFLAGS; \
1255 CFLAGS="${CFLAGS:-%rpmcppflags %rpmcflags}"; export CFLAGS; \
1256 CXXFLAGS="${CXXFLAGS:-%rpmcppflags %rpmcxxflags}"; export CXXFLAGS; \
1257 %{?__cc:CC="%{__cc}"; export CC;} \
1258 %{?__cxx:CXX="%{__cxx}"; export CXX;} \
1259 %{__python3} setup.py build --build-base=build-3 \
1260}
1261
1262# "shrink" filter to keep this macro without newlines,
1263# so it could be used as make arguments
1264%py3_install_opts() %{shrink: \
1265 --prefix=%{_prefix} \
1266 --install-purelib=%{py3_sitescriptdir} \
1267 --install-platlib=%{py3_sitedir} \
1268 --optimize=2 \
1269}
1270
1271%py3_install { \
1272 LDFLAGS="${LDFLAGS:-%rpmldflags}"; export LDFLAGS; \
1273 CFLAGS="${CFLAGS:-%rpmcppflags %rpmcflags}"; export CFLAGS; \
1274 CXXFLAGS="${CXXFLAGS:-%rpmcppflags %rpmcxxflags}"; export CXXFLAGS; \
1275 %{?__cc:CC="%{__cc}"; export CC;} \
1276 %{?__cxx:CXX="%{__cxx}"; export CXX;} \
1277 %{__python3} setup.py \
1278 build --build-base=build-3 \
1279 install --skip-build \
1280 %{py3_install_opts} \
1281 --root=$RPM_BUILD_ROOT \
1282}
1283
1284# node.js libdir
1285# Requirements:
1286# BuildRequires: rpmbuild(macros) >= 1.634
1287%nodejs_libdir /usr/lib/node_modules
1288
1289# bash-completion 2.0 completions dir
1290# Requirements:
1291# BuildRequires: rpmbuild(macros) >= 1.673
1292# Requires: bash-completion >= 2.0
1293%bash_compdir /usr/share/bash-completion/completions
1294
1295# fish completions dir
1296# Requirements:
1297# BuildRequires: rpmbuild(macros) >= 1.720
1298%fish_compdir /usr/share/fish/vendor_completions.d
1299
1300# zsh completions dir
1301# Requirements:
1302# BuildRequires: rpmbuild(macros) >= 1.719
1303%zsh_compdir /usr/share/zsh/site-functions
1304
1305# Hardlink binary identical .pyc and .pyo files
1306%__spec_install_post_py_hardlink {\
1307%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
1308%{!?debug:set +x;} \
1309local a b c=0 t=0 pyc=%{tmpdir}/%{name}-%{version}-%{release}__rpm_pyc; \
1310if [ -d "$RPM_BUILD_ROOT" ]; then \
1311 find "$RPM_BUILD_ROOT" -name '*.pyc' > $pyc; \
1312 while read a; do \
1313 b="${a%.pyc}.pyo"; \
1314 if cmp -s "$a" "$b"; then \
1315 ln -f "$a" "$b"; \
1316 c=$((c + 1)); \
1317 fi; \
1318 t=$((t + 1)); \
1319 done < $pyc; \
1320 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
1321 rm -f $pyc; \
1322fi; \
1323}; __spec_install_post_py_hardlink } }
1324
1325# Remove Python 2.x sources,
1326# PLD Linux policy is to package only compiled .py[co] for Python 2.x libraries.
1327# Author: Elan Ruusamäe <glen@pld-linux.org>
1328#
1329# Usage:
1330# %py_postclean /usr/share/extra -x keepme.py,keeptoo.py
1331# Options:
1332# -x - comma separated of file basenames to preserve (rpmbuild(macros) >= 1.658)
1333# ARGS - extra directories to clean for .py sources
1334#
1335# BuildRequires: rpmbuild(macros) >= 1.189
1336#
1337%py_postclean(x:) \
1338for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
1339 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 %{-x:| grep -ZzvE '/(%(echo '%{-x*}' | tr ',' '|'))$'} | xargs -0r -l512 rm;\
1340done \
1341%{nil}
1342
1343# depmod macro
1344%depmod() { \
1345umask 022; \
1346if [ -e /boot/System.map-%1 ]; then \
1347 /sbin/depmod -a -F /boot/System.map-%1 %1; \
1348else \
1349 if [ -e /boot/System.map ]; then \
1350 /sbin/depmod -a -F /boot/System.map %1; \
1351 else \
1352 /sbin/depmod -a %1; \
1353 fi \
1354fi; \
1355}
1356
1357# XMMS specific macros
1358%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
1359%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
1360%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
1361%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1362%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1363%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1364%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1365%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1366%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1367%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1368
1369# user/group checking macros
1370#
1371# Usage:
1372# %userremove myuser
1373#
1374%userremove /usr/lib/rpm/user_group.sh user del
1375%groupremove /usr/lib/rpm/user_group.sh group del
1376#
1377# Usage:
1378# if %usertestrm myuser; then
1379# /usr/sbin/userdel -r myuser
1380# Note:
1381# use these macros only if you need to call userdel/groupdel with
1382# a non-standard option or take an extra action; otherwise use the
1383# %userremove/%groupremove macros
1384#
1385%usertestrm /usr/lib/rpm/user_group.sh user testrm
1386%grouptestrm /usr/lib/rpm/user_group.sh group testrm
1387# user group membership management macros
1388#
1389# Usage:
1390# %addusertogroup [-q] myuser agroup
1391#
1392# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1393#
1394# Requirements:
1395# BuildRequires: rpmbuild(macros) >= 1.515
1396%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1397%{nil}
1398
1399# banner support (useful in {pre,post}{,un} and triggers)
1400#
1401# Usage:
1402# %banner name [-a] [-e] [-n] [-tn] [-o] <<EOF
1403# the banner text, the banner text
1404# the banner text, and following line
1405#EOF
1406# You can use any form of here-document, <<'EOF' <<-EOT will do.
1407# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1408#
1409# -a - append to the banner
1410# -e - send to stderr instead of stdout
1411# -n - don't show banner (overrides -t)
1412# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1413# -o - show only once, i.e when package is installed for the first time
1414#
1415# Tests:
1416# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1417# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1418# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m 1
1419# rpm -E 'date | %banner -e banner' > m; sh -x m
1420# rpm -E 'date | %banner -o -e banner' > m; sh -x m
1421#
1422%banner(aenot:) %{-o:([ "$1" != 1 ] ||} ( \
1423RPM_SCRIPTVERBOSITY=5 \
1424[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1425if [ -x /usr/bin/banner.sh ]; then \
1426 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1427else \
1428 CMD="cat%{-e: >&2}" \
1429fi \
1430eval $CMD %{?2:%2}%{?3: %3})%{-o:)} \
1431%{nil}
1432
1433# useradd/groupadd macros
1434# Author: Elan Ruusamäe <glen@pld-linux.org>
1435#
1436# Usage:
1437# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1438# [-g initial_group] [-G group[,...]] login
1439#
1440# -u uid. REQUIRED
1441# -g gid/group. REQUIRED
1442# -s defaults to /bin/false
1443# -d defaults to /usr/share/empty
1444# -c No default
1445# -r is accepted but ignored (it's always set)
1446# -k skeleton dir. defaults to /usr/share/empty
1447# rpm specific flags
1448# -P package name. defaults to %{name}
1449#
1450%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
1451%{!-u:%{error:useradd: Required argument -u missing}} \
1452%{!-g:%{error:useradd: Required argument -g missing}} \
1453%{!?1:%{error:useradd: Required parameter login missing}} \
1454if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1455 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1456 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1457 exit 1 \
1458 fi \
1459else \
1460 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1461 /usr/sbin/useradd \\\
1462 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
1463 -u %{-u*} \\\
1464 -r \\\
1465 -d %{-d*}%{!-d:/usr/share/empty} \\\
1466 -s %{-s*}%{!-s:/bin/false} \\\
1467 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1468 -g %{-g*} \\\
1469 %{-M} \\\
1470 %{-G:-G %{-G*}} \\\
1471 %{expand:%{%{#}}} 1>&2 || exit $? \
1472 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1473fi;
1474# vim: "
1475
1476# Usage:
1477# %groupadd [-P package] [-g gid] group
1478#
1479# -g gid. REQUIRED
1480#
1481# Sample:
1482# %groupadd -P %{name}-base -g %{gid} %{name}
1483
1484%groupadd(g:P:rfo) \
1485%{!-g:%{error:groupadd: Required argument -g missing}} \
1486%{!?1:%{error:groupadd: Required parameter group missing}} \
1487if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1488 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1489 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1490 exit 1 \
1491 fi \
1492else \
1493 echo "Adding group %{1} GID=%{-g*}." \
1494 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1495 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1496fi;
1497
1498# webapp macros
1499# Author: Elan Ruusamäe <glen@pld-linux.org>
1500#
1501# The config is installed/removed inside trigger, this means that you can any
1502# time install apache1/apache/lighttpd package and the configuration file is
1503# updated. if you don't need the config for various reason for specific
1504# webserver, just remove the symlink from config directory using webapp
1505# program. the trigger will not recreate the symlink on upgrades. In other
1506# words the config is linked to webserver config directory on first install of
1507# PACKAGE or WEBSERVER.
1508#
1509# Add package's webserver config to webserver webapps dir.
1510# Usage:
1511# %webapp_register [-f] WEBSERVER WEBAPP
1512#
1513%webapp_register(f) \
1514%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1515if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ]); then\
1516 /usr/sbin/webapp register %1 %2\
1517fi\
1518# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
1519if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
1520 %{expand:%service -q %%1 reload}\
1521fi\
1522%{nil}
1523
1524# Remove package's config from webserver webapps dir.
1525# Usage:
1526# %webapp_register [-f] WEBSERVER WEBAPP
1527%webapp_unregister(f) \
1528%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1529# remove link if either of the packages are gone \
1530if [ -n "%{-f:1}" ] || ([ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]); then \
1531 /usr/sbin/webapp unregister %1 %2\
1532 %{expand:%service -q %%1 reload}\
1533fi \
1534%{nil}
1535
1536# service macro.
1537# Author: Elan Ruusamäe <glen@pld-linux.org>
1538#
1539# calls usual service restart on package %post, but skips the restart if
1540# administrator has disabled automatic service restarts in either global
1541# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1542# NOTE: systemd_booted machines do not print
1543# Run "{command}" to restart {service}.
1544# message for packages without native systemd unit (not here, no %systemd_post).
1545#
1546# Usage:
1547# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1548#
1549# -q be silent when service isn't started (for scriplets restaring other package's services)
1550# -n NOOP mode, do not actually restart service
1551#
1552# Requirements:
1553# BuildRequires: rpmbuild(macros) >= 1.268
1554# Requires: rc-scripts
1555# -n option:
1556# BuildRequires: rpmbuild(macros) >= 1.450
1557%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1} RPM_BUILD_ROOT=%{buildroot}; /usr/lib/rpm/service_generator.sh %{*}) };}
1558
1559# Java macros. based on jpackage macros.java
1560#
1561# Root directory where all Java VMs/SDK/JREs are installed.
1562%_jvmdir %{_libdir}/jvm
1563
1564# Root directory where all Java VMs/SDK/JREs expose their jars
1565%_jvmjardir %{_libdir}/jvm-exports
1566
1567# Root directory for all Java VM/SDK/JRE's private things.
1568%_jvmprivdir %{_libdir}/jvm-private
1569
1570# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1571%_jvmlibdir %{_libdir}/jvm
1572
1573# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1574%_jvmdatadir %{_datadir}/jvm
1575
1576# Root directory for all configurations parts of Java VM/SDK/JRE's
1577%_jvmsysconfdir %{_sysconfdir}/jvm
1578
1579# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1580%_jvmcommonlibdir %{_libdir}/jvm-common
1581
1582# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1583%_jvmcommondatadir %{_datadir}/jvm-common
1584
1585# Root directory for all common configurations parts of Java VM/SDK/JRE's
1586%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
1587
1588# Directory where arch-specific (JNI) version-independent jars are installed.
1589%_jnidir %{_libdir}/java
1590
1591
1592# JDK selection. Set this to name of the JDK implementation to use
1593# insead of the system default
1594#%use_jdk icedtea6
1595
1596# expands to the value with right jdk for BuildRequires header
1597# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1598# The requirement will not replace current 'default' JDK
1599%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1600
1601%buildrequires_jdk BuildRequires: %required_jdk
1602
1603%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
1604
1605%_javasrcdir %{_usrsrc}/java
1606
1607%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1608%jar %{java_home}/bin/jar
1609%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
1610%javac %{java_home}/bin/javac
1611%javadoc %{java_home}/bin/javadoc
1612
1613%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
1614
1615%jpackage_script() \
1616install -d $RPM_BUILD_ROOT%{_bindir}\
1617cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1618#!/bin/sh\
1619#\
1620# %{name} script\
1621# JPackage Project <http://www.jpackage.org/>\
1622\
1623# Source functions library\
1624. %{_javadir}-utils/java-functions\
1625\
1626# Source system prefs\
1627if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1628 . %{_sysconfdir}/java/%{name}.conf\
1629fi\
1630\
1631# Source user prefs\
1632if [ -f $HOME/.%{name}rc ]; then\
1633 . $HOME/.%{name}rc\
1634fi\
1635\
1636# Configuration\
1637MAIN_CLASS=%1\
1638BASE_FLAGS=%2\
1639BASE_OPTIONS=%3\
1640BASE_JARS="%(echo %4 | tr ':' ' ')"\
1641\
1642# Set parameters\
1643set_jvm\
1644set_classpath $BASE_JARS\
1645set_flags $BASE_FLAGS\
1646set_options $BASE_OPTIONS\
1647\
1648# Let's start\
1649run "$@"\
1650EOF
1651
1652# jpackage 1.7
1653# Directory for maven depmaps
1654#
1655%_mavendepmapdir /etc/maven
1656%_mavendepmapfragdir /etc/maven/fragments
1657
1658#
1659# add_to_depmap adds an entry to the depmap. The arguments are:
1660#
1661# %1 the original groupid
1662# %2 the original artifact id
1663# %3 the version
1664# %4 the new groupid
1665# %5 the new artifactid
1666#
1667
1668%add_to_maven_depmap() \
1669install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1670cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1671<dependency>\
1672 <maven>\
1673 <groupId>%1</groupId>\
1674 <artifactId>%2</artifactId>\
1675 <version>%3</version>\
1676 </maven>\
1677 <jpp>\
1678 <groupId>%4</groupId>\
1679 <artifactId>%5</artifactId>\
1680 <version>%3</version>\
1681 </jpp>\
1682</dependency>\
1683\
1684EOF\
1685%{nil}
1686
1687#==============================================================================
1688#
1689# update_maven_depmap updates the main maven depmap
1690#
1691%update_maven_depmap() \
1692echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1693if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1694cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1695fi\
1696echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1697
1698# JAVA macros specific for PLD
1699
1700# Directory for tomcat context configuration files
1701%_tomcatconfdir /etc/tomcat/Catalina/localhost
1702
1703# Tomcat cache path
1704%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1705
1706# Clear tomcat cache
1707# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1708#
1709# Usage:
1710# %%tomcat_clear_cache appname
1711#
1712# Call this script in %postun scriptlet. It will remove compiled jsps related to
1713# given app.
1714#
1715%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1716
1717# PEAR install macros
1718# Author: Elan Ruusamäe <glen@pld-linux.org>
1719#
1720# Usage:
1721# %%pear_package_setup ...
1722#
1723# -a # - also unpack SOURCE#. for PEAR bootstrapping
1724# -n FMT - create builddir with FMT, instead of default %%{pearname}-%%{version}
1725# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1726# -D - pass -D to %setup (so the build dir is not removed)
1727# -c - register channel from local channel.xml file
1728# -d - pass -d arg to pearcmd
1729#
1730# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1731# destination hierarchy. you should copy the tree to buildroot after
1732# patching/reorganizing with %%pear_package_install.
1733#
1734# additionally BUILDROOT is stripped from files and files are converted to UNIX
1735# line endings.
1736#
1737# the pear install process output is recorded to install.log, you should put it
1738# to %%doc for later debug or just for information.
1739#
1740# additionally additional-packages.txt is produced if it was detected that the
1741# package has optional dependencies. the file format is suitable of displaying
1742# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1743# automatically added for this file.
1744
1745
1746# records install.log and transforms PEAR names to PLD Linux rpm package names.
1747%__pear_install_log \
1748tee install.log \
1749# make post message of optional packages \
1750grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,' > optional-packages.txt \
1751if [ -s optional-packages.txt ]; then \
1752 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1753else \
1754 rm -f optional-packages.txt \
1755fi \
1756%{nil}
1757
1758# Command invoking PEAR CLI
1759# Same as /usr/bin/pear, except we force GMT timezone
1760%__pear %__php -doutput_buffering=1 -dopen_basedir="" -dmemory_limit=-1 -ddate.timezone=GMT /usr/share/pear/pearcmd.php
1761
1762%pear_install(a:d:n:zD) \
1763%__pear \\\
1764 -c %{builddir}/pearrc \\\
1765 -d doc_dir=/docs \\\
1766 -d temp_dir=/tmp \\\
1767 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1768 -d bin_dir=%{_bindir} \\\
1769 -d data_dir=%{php_pear_dir}/data \\\
1770 -d test_dir=%{php_pear_dir}/tests \\\
1771 %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
1772 install \\\
1773 --packagingroot=%{builddir} \\\
1774 --offline \\\
1775 --nodeps \\\
1776 %{-f:--force} \\\
1777 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1778 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1779%{nil}
1780
1781# The main macro.
1782# using this macro will append optional-packages.txt to the nocompressdoc list
1783# as it's displayed to user after package install. and adding additional gzip
1784# dep is just waste ;)
1785%pear_package_setup(a:d:n:zDc:) \
1786%define srcdir %{-n*}%{!-n:%{?_pearname}%{!?_pearname:%{pearname}}-%{version}} \
1787%define builddir %{_builddir}/%{srcdir} \
1788%setup -q -c -T %{-D:-D} -n %{srcdir} \
1789%{-z:%{__tar} zxf %{S:0}; %{-a:%{__tar} zxf %{S:%{-a*}}}} \
1790%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1791%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1792%pear_install \
1793%{-z:cd ..} \
1794%{__tar} --wildcards -zvxf %{S:0} package*.xml \
1795cat %{-z:$_N/}.install.log | %__pear_install_log \
1796%undos -f php,html,js,xml \
1797%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1798%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1799%{nil}
1800
1801# Copies extracted PEAR package structure and PEAR registry to buildroot.
1802# Author: Elan Ruusamäe <glen@pld-linux.org>
1803%pear_package_install() \
1804cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1805# tests should not be packaged \
1806%{__rm} -rf $RPM_BUILD_ROOT%{php_pear_dir}/tests \
1807# cleanup backups \
1808find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1809# help the developer out a little: \
1810if [ -f _noautoreq ]; then \
1811 echo "AutoReqdep detected:" \
1812 echo "_noautoreq $(cat _noautoreq)" \
1813fi \
1814%{nil}
1815
1816# Print optional package info for pear packages
1817# Author: Elan Ruusamäe <glen@pld-linux.org>
1818# Usage:
1819# %post -p <lua>
1820# %%pear_package_print_optionalpackages
1821#
1822# Requirements:
1823# BuildRequires: rpmbuild(macros) >= 1.571
1824%pear_package_print_optionalpackages \
1825f = io.open("%{_docdir}/%{name}-%{version}/optional-packages.txt", "r") \
1826if f then \
1827 for l in f:lines() do print(l); end \
1828 f:close() \
1829end \
1830%{nil}
1831
1832
1833# Register OpenLDAP schema.
1834# Author: Elan Ruusamäe <glen@pld-linux.org>
1835#
1836# Usage:
1837# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1838#
1839# -d specify dependant schemas, separated by comma
1840#
1841%openldap_schema_register(d:) \
1842for schema in %*; do \
1843 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1844 %{__sed} -i -e " \
1845 /^include.*local.schema/{ \
1846 iinclude\\t $schema\
1847 } \
1848 " /etc/openldap/slapd.conf \
1849 fi \
1850done \
1851# enable dependant schemas \
1852if [ "%{-d*}" ]; then \
1853 %{__sed} -i -e ' \
1854 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1855 s/^#// \
1856 }' /etc/openldap/slapd.conf \
1857fi \
1858%{nil}
1859
1860# Unregister OpenLDAP schema.
1861# Author: Elan Ruusamäe <glen@pld-linux.org>
1862#
1863# Usage:
1864# %%openldap_schema_unregister %{schemadir}/horde.schema
1865#
1866%openldap_schema_unregister() \
1867for schema in %*; do \
1868 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1869 %{__sed} -i -e " \
1870 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1871 # for symmetry it would be nice if we disable enabled schemas in post, \
1872 # but we really can not do that, it would break something else. \
1873 " /etc/openldap/slapd.conf \
1874 fi \
1875done \
1876%{nil}
1877
1878%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1879
1880# patchset macros
1881# generate SourceX urls from range START STOP
1882# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1883# The sources start from 10000
1884#
1885# Author: Elan Ruusamäe <glen@pld-linux.org>
1886#
1887# Usage:
1888# %patchset_source -f <seq(1) format> <start> [<end>]
1889# %patchset_patch <start> [<end>]
1890# If <end> is omited, it is assumed to be <start>.
1891#
1892# For example in preamble:
1893# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1894# and in %prep:
1895# %patchset_patch 33 44
1896#
1897# Using sources list:
1898# BuildRequires: rpmbuild(macros) >= 1.426
1899# %patchset_source -f <url> -s <filelist>
1900# %patchset_patch -s <filelist>
1901# For example (ncurses):
1902# BuildRequires: rpmbuild(macros) >= 1.683
1903# %patchset_source -f ftp://dickey.his.com/ncurses/%{basever}/ -s sources
1904# %patchset_patch -s sources -p1
1905#
1906
1907%patchset_source(f:b:s:) %(
1908 base=%{-b*}%{!-b*:10000}
1909%{-s:
1910 baseurl='%{-f*}'
1911 filelist='%{-s*}'
1912 i=$base
1913 while read checksum file; do
1914 printf "Patch%d: %s%s\\n" $i "$baseurl" "$file"
1915 i=$((i+1))
1916 done < $filelist
1917}
1918%{!-s:
1919 start=$(expr $base + %1);
1920 end=$(expr $base + %{?2}%{!?2:%{1}});
1921 # we need to call seq twice as it doesn't allow two formats
1922 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1923 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1924 paste %{tmpdir}/__ps{1,2};
1925 rm -f %{tmpdir}/__ps{1,2};
1926}
1927) \
1928%{nil}
1929
1930# apply sources from %patchset_source
1931# -p specify -pX for %patch line
1932# -b base offset: defaults to 10000
1933# -s filelist to read files from
1934%patchset_patch(f:p:b:s:) %(
1935 base=%{-b*}%{!-b*:10000}
1936 patchlevel=%{-p*:-p%{-p*}}
1937%{-s:
1938 filelist='%{-s*}'
1939 i=$base
1940 while read checksum file; do
1941 printf "patch%d %s\\n" $i "$patchlevel" | sed -e s,^,%%,
1942 i=$((i+1))
1943 done < $filelist
1944}
1945%{!-s:
1946 start=$(expr $base + %1);
1947 end=$(expr $base + %{?2}%{!?2:%{1}});
1948 echo ": patchset_patch %1%{?2: to %2}";
1949 seq -f "patch%g $patchlevel" $start $end | sed -e s,^,%%,;
1950}
1951) \
1952%{nil}
1953
1954# return EXPANDED source url N from current spec
1955%sourceurl(n:) %(test "$IN_RPM" = 1 && exit 1; export IN_RPM=1; rpmbuild --nodigest --nosignature --nobuild -D "prep %%dump" %{_specdir}/%{name}.spec 2>&1 | awk '$2 ~ /^SOURCEURL%{-n*}/ {print $3}')
1956
1957# browser plugins v2
1958# Author: Elan Ruusamäe <glen@pld-linux.org>
1959#
1960# Usage:
1961# %browser_plugins_add_browser <name> -p <plugindir>
1962#
1963# <name> (required) -- name of the browser. usually %{name}.
1964# -p <plugindir> (required) -- in what directory browser searches for its plugins.
1965# -b -- default blacklists
1966# -a <arch> override arch
1967#
1968# Example:
1969# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1970
1971%_browserpluginsconfdir /etc/browser-plugins
1972%_browserpluginsdir %{_libdir}/browser-plugins
1973%update_browser_plugins /usr/sbin/update-browser-plugins || :
1974
1975%browser_plugins_add_browser(p:b:a:) \
1976 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1977 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1978 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1979 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1980 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1981 %{-b:cat >> $blacklist_file %{-b*}} \
1982%{nil}
1983
1984# Helper for LUA.
1985# split string separated by space into quoted list
1986#
1987# Author: Elan Ruusamäe <glen@pld-linux.org>
1988#
1989# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1990%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1991
1992# adjust /etc/shells by adding and removing shells from there
1993# Author: Elan Ruusamäe <glen@pld-linux.org>
1994#
1995# Usage:
1996# %post -p <lua>
1997# %lua_add_etc_shells /bin/sh /bin/pdksh
1998#
1999# %preun -p <lua>
2000# if arg[2] == 0 then
2001# %lua_remove_etc_shells /bin/bash /bin/rbash
2002# end
2003#
2004# Requirements:
2005# BuildRequires: rpmbuild(macros) >= 1.462
2006#
2007
2008%lua_add_etc_shells() \
2009t = {}\
2010f = io.open("/etc/shells", "r")\
2011if f then\
2012 for l in f:lines() do t[l]=l; end\
2013 f:close()\
2014end\
2015for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
2016 if not t[s] then\
2017 print("Adding "..s.." to /etc/shells")\
2018 f = io.open("/etc/shells", "a")\
2019 if f then\
2020 f:write(s.."\\n")\
2021 f:close()\
2022 end\
2023 end\
2024end\
2025%{nil}
2026
2027%lua_remove_etc_shells() \
2028t = {}\
2029f = io.open("/etc/shells", "r")\
2030if f then\
2031 for l in f:lines() do t[l]=l; end\
2032 f:close()\
2033end\
2034for _, l in pairs({%{expand:%%__lua_split %*}}) do\
2035 print("Removing "..l.." from /etc/shells")\
2036 t[l] = nil\
2037end\
2038s=""\
2039for _, l in pairs(t) do\
2040 s=s..l.."\\n"\
2041end\
2042f = io.open("/etc/shells", "w")\
2043if f then\
2044 f:write(s)\
2045 f:close()\
2046end\
2047%{nil}
2048
2049# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
2050#
2051# Author: Elan Ruusamäe <glen@pld-linux.org>
2052#
2053# Usage:
2054# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
2055# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
2056#
2057# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
2058#
2059# Requirements:
2060# BuildRequires: rpmbuild(macros) >= 1.429
2061#
2062%add_etc_shells(p) %{-p:<lua>}\
2063%{expand:%%lua_add_etc_shells %*}\
2064%{nil}
2065
2066%remove_etc_shells(p) %{-p:<lua>}\
2067%{-p:if arg[2] == 0 then}\
2068%{expand:%%lua_remove_etc_shells %*}\
2069%{-p:end} \
2070%{nil}
2071
2072# Check syntax for Python files
2073#
2074# Author: Elan Ruusamäe <glen@pld-linux.org>
2075# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
2076#
2077# Usage:
2078# %py_lint src
2079#
2080# Requirements:
2081# BuildRequires: python
2082# BuildRequires: rpmbuild(macros) >= 1.602
2083
2084%py_lint() \
2085__py_lint() { \
2086%{!?debug:set +x;} \
2087find "$@" -type f -name '*.py' | python -c ' \
2088import sys \
2089import compiler \
2090\
2091found = err = 0\
2092for f in sys.stdin: \
2093 fd = open(f.rstrip()) \
2094 c = fd.read() \
2095 fd.close() \
2096 found = found + 1 \
2097 try: \
2098 compiler.parse(c) \
2099 except SyntaxError, e: \
2100 print "py_lint: %s: %s" % (f.rstrip(), e) \
2101 err = err + 1\
2102\
2103if not found:\
2104 print >> sys.stderr, "\\npy_lint: ERROR: No files processed.\\n" \
2105 sys.exit(1) \
2106elif err: \
2107 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
2108 sys.exit(1) \
2109else: \
2110 print >> sys.stderr, "py_lint: %d files scanned, found no syntax errors." % found \
2111' \
2112}; __py_lint %* \
2113%{nil}
2114
2115# Undos files
2116#
2117# Author: Paweł Zuzelski <pawelz@pld-linux.org>
2118# Author: Elan Ruusamäe <glen@pld-linux.org>
2119#
2120# Usage:
2121# %undos list_of_files
2122# %undos -f EXT[,EXT]
2123# %undos -i -f EXT[,EXT]
2124#
2125# -f EXT[,EXT] - find(1) files by extensions
2126# -i - case insensitive file search
2127#
2128# Example:
2129# Un-DOS all *.js, *.css files
2130# %undos -f js,css
2131# Un-DOS all *.js, *.JS files
2132# %undos -f js -i
2133# undos all Makefiles
2134# %{__find} -name Makefile | xargs %undos
2135#
2136# Requirements:
2137# BuildRequires: sed >= 4.0
2138# BuildRequires: rpmbuild(macros) >= 1.674
2139
2140# NB: make sure this macro stays on one line
2141# NB: make sure it includes newline escape
2142%undos(f:i) %{-f:%{__find} -type f -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
2143%{nil}
2144
2145# Hook to register nagios object based plugins in Nagios NRPE daemon config.
2146#
2147# Author: Elan Ruusamäe <glen@pld-linux.org>
2148#
2149# Usage:
2150# -a NAME -- add command named NAME
2151# -d NAME -- remove command named NAME
2152# -f FILE -- specify plugin configuration FILE to extract command definition from
2153#
2154# Sample:
2155# %triggerin -- nagios-nrpe
2156# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
2157#
2158# %triggerun -- nagios-nrpe
2159# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
2160#
2161# Requirements:
2162# Requires: grep
2163# Requires: sed >= 4.0
2164# BuildRequires: rpmbuild(macros) >= 1.685
2165%nagios_nrpe(a:d:c:f:) {\
2166 if %{__grep} -q '^include_dir=/etc/nagios/nrpe.d' /etc/nagios/nrpe.cfg && [ -d /etc/nagios/nrpe.d ]; then \
2167 file=/etc/nagios/nrpe.d/%{-a*}%{-d*}.cfg; \
2168 else \
2169 file=/etc/nagios/nrpe.cfg; \
2170 fi; \
2171 m=$(test -f $file && md5sum < $file); \
2172 %{-a:# on -a and config exists \
2173 if [ -f /etc/nagios/nrpe.cfg ]; then \
2174 if [ ! -f $file ] || ! %{__grep} -q '^command\[%{-a*}\]' $file; then \
2175 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> $file; \
2176 fi; \
2177 fi;} \
2178 %{-d:# on package remove, -d and config exists \
2179 if [ "$1" = "0" -a -f $file ]; then \
2180 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' $file; \
2181 fi;} \
2182 if [ "$m" != "$(md5sum < $file)" ]; then \
2183 %service -q nrpe restart; \
2184 fi; \
2185}%{nil}
2186
2187# Import or update Cacti template.
2188#
2189# Author: Elan Ruusamäe <glen@pld-linux.org>
2190#
2191# Usage:
2192# %cacti_import_template XMLFILE
2193# XMLFILE -- XML template to import
2194#
2195# Sample:
2196# %post
2197# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
2198#
2199# Requires: cacti >= 0.8.7e-8
2200# BuildRequires: rpmbuild(macros) >= 1.630
2201# Note: 1.1 (cacti-0.8.7h) adds requirement for --with-template-rras or --with-user-rras option
2202
2203%cacti_import_template() {\
2204v=$(%{__sed} -rne 's/.+Add Graphs Script ([0-9\.]+).+/\1/p' /usr/share/cacti/cli/import_template.php); \
2205if [ "$v" != "1.0" ]; then \
2206 rra="--with-template-rras"; \
2207fi; \
2208/usr/share/cacti/cli/import_template.php --filename=%1 $rra || :; \
2209}%{nil}
2210
2211# pre/post script for -upstart subpackages
2212#
2213# Author: Jacek Konieczny <jajcus@jajcus.net>
2214# Author: Elan Ruusamäe <glen@pld-linux.org>
2215#
2216# Usage:
2217# %upstart_post service_name
2218# %upstart_postun service_name
2219#
2220# Sample:
2221# %post upstart
2222# %upstart_post %{name}
2223#
2224# %postun upstart
2225# %upstart_postun %{name}
2226#
2227# Requirements:
2228# BuildRequires: rpmbuild(macros) >= 1.690
2229# Requires: rc-scripts >= 0.4.3
2230
2231# migrate from init script to upstart job
2232%upstart_post() \
2233 if [ -x /sbin/initctl ] && [ -f /var/lock/subsys/%1 ]; then \
2234 /sbin/service --no-upstart %1 stop \
2235 /sbin/service %1 start \
2236 fi \
2237%{nil}
2238
2239# restart the job after upgrade or migrate to init script on removal
2240# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
2241# at this point
2242%upstart_postun() \
2243 if [ -x /sbin/initctl ] && /sbin/initctl status %1 2>/dev/null | grep -q 'running' ; then \
2244 /sbin/initctl stop %1 >/dev/null 2>&1 \
2245 [ -f /etc/rc.d/init.d/%1 -o -f /etc/init/%1.conf ] && { echo -n "Re-"; /sbin/service %1 start; }; \
2246 fi \
2247%{nil}
2248
2249# Haskell Macros
2250# BuildRequires: rpmbuild(macros) >= 1.608
2251%ghcdir ghc-%(/usr/bin/ghc --numeric-version 2>/dev/null || echo ERROR)
2252
2253# update /usr/lib*/ghc-*/package.conf.d/package.cache
2254# Requires: ghc
2255# BuildRequires: rpmbuild(macros) >= 1.607
2256#
2257%ghc_pkg_recache() {{ \
2258 umask 022; \
2259 [ ! -x /usr/bin/ghc-pkg ] || /usr/bin/ghc-pkg recache; \
2260};} \
2261%{nil}
2262
2263
2264# pre/post script for packages supporting systemd units
2265#
2266# Authors: Bartlomiej Zimon <uzi18@o2.pl>
2267# Jan Rękorajski <baggins@mimuw.edu.pl>
2268#
2269# Usage:
2270# %systemd_reload
2271# %systemd_service <unit command> service_name1.service service_name2.service
2272# %systemd_service_enable service_name1.service service_name2.service
2273# %systemd_service_disable service_name1.service service_name2.service
2274# %systemd_service_start service_name1.service service_name2.service
2275# %systemd_service_stop service_name1.service service_name2.service
2276# %systemd_service_restart service_name1.service service_name2.service
2277# %systemd_service_reload service_name1.service service_name2.service
2278#
2279# %systemd_post service_name1.service service_name2.service
2280# %systemd_preun service_name1.service service_name2.service
2281# %systemd_trigger service_name1.service service_name2.service
2282#
2283# Sample:
2284# %post
2285# %systemd_post %{name}.service
2286#
2287# %preun
2288# %systemd_preun %{name}.service
2289#
2290# %postun
2291# %systemd_reload
2292#
2293# %triggerpostun -- %{name} < first-version-with-systemd-units
2294# %systemd_trigger %{name}.service
2295#
2296# Requirements:
2297# BuildRequires: rpmbuild(macros) >= 1.671
2298# Requires: systemd-units >= 38
2299
2300%systemd_reload /bin/systemd_booted && SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog /bin/systemctl daemon-reload || :
2301
2302%systemd_service_enable() \
2303 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2304 /bin/systemctl preset --preset-mode=enable-only %{*} || : \
2305 /bin/systemd_booted && echo 'Run "/bin/systemctl start %{*}" to start %{*}.' || : \
2306%{nil}
2307
2308%systemd_service_disable() \
2309 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2310 /bin/systemctl --quiet disable %{*} || : \
2311%{nil}
2312
2313%systemd_service() \
2314 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2315 /bin/systemd_booted && /bin/systemctl %{*} || : \
2316%{nil}
2317
2318%systemd_service_start() \
2319 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2320 /bin/systemd_booted && /bin/systemctl start %{*} || : \
2321%{nil}
2322
2323%systemd_service_stop() \
2324 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2325 /bin/systemd_booted && /bin/systemctl stop %{*} || : \
2326%{nil}
2327
2328# NOTE: doesn't honour RPM_SKIP_AUTO_RESTART, avoid using
2329%systemd_service_restart() \
2330 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2331 /bin/systemd_booted && /bin/systemctl try-restart %{*} || : \
2332%{nil}
2333
2334# NOTE: doesn't honour RPM_SKIP_AUTO_RESTART, avoid using
2335%systemd_service_reload() \
2336 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2337 /bin/systemd_booted && /bin/systemctl reload %{*} || : \
2338%{nil}
2339
2340# NOTE: this trigger disobeys systemd.preset in favour of RPM_ENABLE_SYSTEMD_SERVICE
2341%systemd_trigger() \
2342want_enable_service() { \
2343 [ -f /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
2344 [ ${RPM_ENABLE_SYSTEMD_SERVICE:-yes} = no ] && return 1 \
2345 [ "$(echo /etc/rc.d/rc[0-6].d/S[0-9][0-9]${1%.service})" = "/etc/rc.d/rc[0-6].d/S[0-9][0-9]${1%.service}" ] && return 1 \
2346 return 0 \
2347}\
2348 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2349 for s in %{*}; do \
2350 if want_enable_service $s; then \
2351 /bin/systemctl enable $s || : \
2352 fi \
2353 done \
2354%{nil}
2355
2356%systemd_post() \
2357 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2358 /bin/systemd_booted && /bin/systemctl daemon-reload || : \
2359 if [ $1 -eq 1 ]; then \
2360 /bin/systemctl preset --preset-mode=enable-only %{*} >/dev/null || : \
2361 /bin/systemd_booted && echo 'Run "/bin/systemctl start %{*}" to start %{*}.' || : \
2362 elif [ -z "$NORESTART" ]; then \
2363 /bin/systemd_booted && /bin/systemctl try-restart %{*} || : \
2364 else \
2365 /bin/systemd_booted && echo 'Run "/bin/systemctl restart %{*}" to restart %{*}.' || : \
2366 fi \
2367%{nil}
2368
2369%systemd_preun() \
2370 if [ $1 -eq 0 ]; then \
2371 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2372 /bin/systemd_booted && /bin/systemctl stop %{*} || : \
2373 /bin/systemctl --quiet disable %{*} || : \
2374 fi \
2375%{nil}
2376
2377%systemdunitdir /lib/systemd/system
2378%systemduserunitdir /usr/lib/systemd/user
2379%systemdtmpfilesdir /usr/lib/tmpfiles.d
2380
2381# BuildRequires: rpmbuild(macros) >= 1.721
2382%journal_catalog_update() [ ! -x /bin/journalctl ] || /bin/journalctl --update-catalog >/dev/null 2>&1 || :
2383
2384#-----------------------------------------------------------------
2385# Update hardware database index
2386#
2387# Requirements:
2388# BuildRequires: rpmbuild(macros) >= 1.691
2389# Requires: udev-core >= 1:196
2390
2391%udev_hwdb_update() \
2392/sbin/udevadm hwdb --update >/dev/null 2>&1 || : \
2393%{nil}
2394
2395# Generate vim help tags file
2396#
2397# Requirements:
2398# BuildRequires: rpmbuild(macros) >= 1.718
2399# Requires(post,postun): /usr/bin/vim
2400# Requires(post,postun): vim-rt >= 4:7.4.2054-2
2401%vim_doc_helptags() \
2402umask 022; \
2403/usr/bin/vim -c ':helptags /usr/share/vim/doc' -c ':q' 2>/dev/null \
2404%{nil}
2405
2406# EOF
This page took 0.084936 seconds and 4 git commands to generate.